//+------------------------------------------------------------------+
//|                                       Better Bollinger bands.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Blue//MediumSeaGreen
#property indicator_color3 Red//DarkOrange
#property indicator_width1 1
#property indicator_width2 4
#property indicator_width3 4

//
//
//
//
//

extern int    BandsLength    =  19;
extern double BandsDeviation = 1.0; 
extern int    AppliedPrice   = PRICE_WEIGHTED;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double tBuffer[][4];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iMt1 0
#define iMt2 1
#define iUt1 2
#define iUt2 3

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    limit,i,r;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);         
         
   //
   //
   //
   //
   //

   double alpha =  2.0/(BandsLength+1.0);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,19,0,MODE_SMA,AppliedPrice,i);
         
         //
         //
         //
         //
         //
         
            tBuffer[r][iMt1] = tBuffer[r-1][iMt1] + alpha*(price           -tBuffer[r-1][iMt1]);
            tBuffer[r][iUt1] = tBuffer[r-1][iUt1] + alpha*(tBuffer[r][iMt1]-tBuffer[r-1][iUt1]);
            double dt  = ((2-alpha)*tBuffer[r][iMt1]-tBuffer[r][iUt1])/(1-alpha);
            double MA=iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i) ;
   
   Buffer1[i] = dt;   
   Buffer2[i] = EMPTY_VALUE; 
   Buffer3[i] = EMPTY_VALUE;
      
      
   if (dt<MA) Buffer2[i]= dt;   
   if (dt>MA) Buffer3[i]= dt;
         //MaBuffer[i]  = dt;
         //UpperBand[i] = dt+BandsDeviation*dt2;
         //LowerBand[i] = dt-BandsDeviation*dt2;
      }            
   return(0);
}